"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withBreakpoints = exports.ResponsiveWrapper = exports.ResponsiveConsumer = exports.Responsive = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _breakpoints = require("../helpers/breakpoints");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var initialBreakpoint = {
  name: 'default',
  value: 0
};

var _React$createContext = /*#__PURE__*/_react.default.createContext(initialBreakpoint),
    Provider = _React$createContext.Provider,
    Consumer = _React$createContext.Consumer;

var ResponsiveConsumer = Consumer;
exports.ResponsiveConsumer = ResponsiveConsumer;

var withBreakpoints = function withBreakpoints(Comp) {
  return function (props) {
    return /*#__PURE__*/_react.default.createElement(ResponsiveConsumer, null, function (breakpoint) {
      return /*#__PURE__*/_react.default.createElement(Comp, _extends({
        breakpoint: breakpoint,
        isGreaterThan: function isGreaterThan(value) {
          return breakpointIsGreaterThan(value, breakpoint.value);
        },
        isLessThan: function isLessThan(value) {
          return breakpointIsLessThan(value, breakpoint.value);
        }
      }, props));
    });
  };
};

exports.withBreakpoints = withBreakpoints;

var ResponsiveWrapper = /*#__PURE__*/function (_Component) {
  _inherits(ResponsiveWrapper, _Component);

  var _super = _createSuper(ResponsiveWrapper);

  function ResponsiveWrapper(props) {
    var _this;

    _classCallCheck(this, ResponsiveWrapper);

    _this = _super.call(this, props);
    _this.state = _objectSpread({}, initialBreakpoint);
    _this.mediaQueries = [];
    return _this;
  }

  _createClass(ResponsiveWrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.mediaQueries = Object.keys(_breakpoints.breakpoints).map(function (key) {
        var query = window.matchMedia("(min-width: ".concat(_breakpoints.breakpoints[key], "px)"));
        query.breakpoint = _breakpoints.breakpoints[key];
        query.name = key;
        query.addListener(function () {
          return _this2.dispatchActiveQuery();
        });
        return query;
      });
      this.dispatchActiveQuery();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;

      var _iterator = _createForOfIteratorHelper(this.mediaQueries),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var query = _step.value;
          query.removeListener(function () {
            return _this3.dispatchActiveQuery();
          });
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "dispatchActiveQuery",
    value: function dispatchActiveQuery() {
      var activeQuery = this.mediaQueries.reduce(function (prev, curr) {
        return curr.matches ? curr : prev && prev.matches ? prev : null;
      });
      var breakpointName = activeQuery ? activeQuery.name : 'default';
      var breakpointSize = activeQuery && activeQuery.breakpoint;
      this.setState({
        name: breakpointName,
        value: breakpointSize
      });
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(Provider, {
        value: _objectSpread({}, this.state)
      }, /*#__PURE__*/_react.default.createElement(_react.Fragment, null, this.props.children));
    }
  }]);

  return ResponsiveWrapper;
}(_react.Component);

exports.ResponsiveWrapper = ResponsiveWrapper;
var propTypes = {
  unmount: _propTypes.default.bool,
  showFor: _propTypes.default.oneOf(['small', 'medium', 'large', 'xlarge']),
  hideFor: _propTypes.default.oneOf(['small', 'medium', 'large', 'xlarge']),
  children: _propTypes.default.any
};

var Responsive = /*#__PURE__*/function (_Component2) {
  _inherits(Responsive, _Component2);

  var _super2 = _createSuper(Responsive);

  function Responsive() {
    _classCallCheck(this, Responsive);

    return _super2.apply(this, arguments);
  }

  _createClass(Responsive, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          unmount = _this$props.unmount,
          showFor = _this$props.showFor,
          hideFor = _this$props.hideFor,
          children = _this$props.children;

      var content = function content(breakpoint) {
        if (showFor && breakpointIsLessThan(showFor, breakpoint.value) || hideFor && breakpointIsGreaterThan(hideFor, breakpoint.value)) {
          if (unmount) {
            return null;
          } else {
            return /*#__PURE__*/_react.default.createElement("div", {
              style: {
                display: 'none'
              }
            }, children);
          }
        } else {
          return children;
        }
      };

      return /*#__PURE__*/_react.default.createElement(Consumer, null, function (breakpoint) {
        return content(breakpoint);
      });
    }
  }]);

  return Responsive;
}(_react.Component);

exports.Responsive = Responsive;
Responsive.propTypes = propTypes;

var breakpointIsGreaterThan = function breakpointIsGreaterThan(breakpointToCompare, currentBreakpointSize) {
  var comparison = typeof breakpointToCompare === 'string' ? _breakpoints.breakpoints[breakpointToCompare] : breakpointToCompare;
  return currentBreakpointSize === null || currentBreakpointSize >= comparison;
};

var breakpointIsLessThan = function breakpointIsLessThan(breakpointToCompare, currentBreakpointSize) {
  var comparison = typeof breakpointToCompare === 'string' ? _breakpoints.breakpoints[breakpointToCompare] : breakpointToCompare;
  return currentBreakpointSize !== null && currentBreakpointSize < comparison;
};