"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ThemeProvider;

var _react = _interopRequireDefault(require("react"));

var _WithStylesContext = _interopRequireDefault(require("react-with-styles/lib/WithStylesContext"));

var _reactWithStylesInterfaceAphrodite = _interopRequireDefault(require("react-with-styles-interface-aphrodite"));

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ThemeProvider(_ref) {
  var customTheme = _ref.customTheme,
      direction = _ref.direction,
      children = _ref.children;
  return /*#__PURE__*/_react.default.createElement(_WithStylesContext.default.Provider, {
    value: {
      stylesInterface: _reactWithStylesInterfaceAphrodite.default,
      stylesTheme: customTheme || _CinnectaTheme.default,
      direction: direction
    }
  }, children);
}