"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _Text = _interopRequireDefault(require("./Text"));

var _Title = _interopRequireDefault(require("./Title"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  after: _propTypes.default.object,
  before: _propTypes.default.object,
  children: _propTypes.default.any.isRequired,
  description: _propTypes.default.string,
  done: _propTypes.default.bool,
  errorMessage: _propTypes.default.string,
  invalid: _propTypes.default.bool,
  title: _propTypes.default.string
});

var ConfigurationItem = /*#__PURE__*/function (_Component) {
  _inherits(ConfigurationItem, _Component);

  var _super = _createSuper(ConfigurationItem);

  function ConfigurationItem() {
    _classCallCheck(this, ConfigurationItem);

    return _super.apply(this, arguments);
  }

  _createClass(ConfigurationItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          after = _this$props.after,
          before = _this$props.before,
          children = _this$props.children,
          css = _this$props.css,
          description = _this$props.description,
          done = _this$props.done,
          errorMessage = _this$props.errorMessage,
          invalid = _this$props.invalid,
          styles = _this$props.styles,
          title = _this$props.title;
      return /*#__PURE__*/_react.default.createElement("div", css(styles.configurationItem), before, /*#__PURE__*/_react.default.createElement("div", css(styles.configurationItem__content), /*#__PURE__*/_react.default.createElement(_Spacing.default, {
        bottom: 1
      }, /*#__PURE__*/_react.default.createElement(_Title.default, {
        noSpacing: true,
        light: true,
        level: 3
      }, title, (done || invalid) && /*#__PURE__*/_react.default.createElement("div", css(styles.statusLabel, done && styles.statusLabel_done, invalid && styles.statusLabel_error), /*#__PURE__*/_react.default.createElement(_Icon.default, {
        micro: true,
        inverse: true,
        name: done ? 'check' : 'error'
      }))), /*#__PURE__*/_react.default.createElement(_Text.default, {
        small: true,
        mutted: true
      }, description)), children, invalid && errorMessage && /*#__PURE__*/_react.default.createElement("div", css(styles.errorMessage), /*#__PURE__*/_react.default.createElement(_Text.default, {
        error: true
      }, "Mensagem de erro"))), after);
    }
  }]);

  return ConfigurationItem;
}(_react.Component);

var ConfigurationItemWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var color = _ref.color,
      units = _ref.units,
      radius = _ref.radius,
      font = _ref.font;
  return {
    configurationItem: {
      borderRadius: radius,
      borderWidth: 1,
      borderColor: color.blueGrayLight,
      borderStyle: 'solid',
      background: color.white,
      overflow: 'hidden'
    },
    configurationItem__content: {
      padding: units(1.5)
    },
    statusLabel: {
      width: 16,
      height: 16,
      marginLeft: 8,
      borderRadius: '50%',
      display: 'inline-flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    statusLabel_done: {
      background: color.success
    },
    statusLabel_error: {
      background: color.alert
    },
    statusLabel__icon: {
      fill: color.white
    },
    errorMessage: {
      background: color.alertLight,
      marginTop: units(1.5),
      marginRight: units(-1.5),
      marginBottom: units(-1.5),
      marginLeft: units(-1.5),
      paddingTop: units(1),
      paddingRight: units(1.5),
      paddingBottom: units(1),
      paddingLeft: units(1.5)
    }
  };
})(ConfigurationItem);
ConfigurationItem.propTypes = propTypes;
var _default = ConfigurationItemWithStyles;
exports.default = _default;