"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactGoogleMaps = require("react-google-maps");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var defaultProps = {
  options: {
    fillColor: '#ee430e',
    strokeColor: '#ee430e',
    strokeWeight: 1,
    fillOpacity: .3,
    strokeOpacity: .5
  }
};

var MapRectangle = /*#__PURE__*/function (_Component) {
  _inherits(MapRectangle, _Component);

  var _super = _createSuper(MapRectangle);

  function MapRectangle() {
    _classCallCheck(this, MapRectangle);

    return _super.apply(this, arguments);
  }

  _createClass(MapRectangle, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          defaultBounds = _this$props.defaultBounds,
          defaultDraggable = _this$props.defaultDraggable,
          defaultEditable = _this$props.defaultEditable,
          defaultOptions = _this$props.defaultOptions,
          defaultVisible = _this$props.defaultVisible,
          bounds = _this$props.bounds,
          draggable = _this$props.draggable,
          editable = _this$props.editable,
          options = _this$props.options,
          visible = _this$props.visible,
          _onDblClick = _this$props.onDblClick,
          _onDragEnd = _this$props.onDragEnd,
          _onDragStart = _this$props.onDragStart,
          _onMouseDown = _this$props.onMouseDown,
          _onMouseMove = _this$props.onMouseMove,
          _onMouseOut = _this$props.onMouseOut,
          _onMouseOver = _this$props.onMouseOver,
          _onMouseUp = _this$props.onMouseUp,
          _onRightClick = _this$props.onRightClick,
          _onBoundsChanged = _this$props.onBoundsChanged,
          _onClick = _this$props.onClick,
          _onDrag = _this$props.onDrag,
          removeMarker = _this$props.removeMarker;
      return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Rectangle, {
        ref: function ref(rectangle) {
          return _this.rectangle = rectangle;
        },
        defaultBounds: defaultBounds,
        defaultDraggable: defaultDraggable,
        defaultEditable: defaultEditable,
        defaultOptions: defaultOptions,
        defaultVisible: defaultVisible,
        bounds: bounds,
        visible: visible,
        options: options,
        draggable: draggable,
        editable: editable,
        onDragStart: function onDragStart() {
          return _this.rectangle && _onDragStart && _onDragStart(_this.rectangle.getBounds());
        },
        onDragEnd: function onDragEnd() {
          return _this.rectangle && _onDragEnd && _onDragEnd(_this.rectangle.getBounds());
        },
        onDrag: function onDrag() {
          return _this.rectangle && _onDrag && _onDrag(_this.rectangle.getBounds());
        },
        onBoundsChanged: function onBoundsChanged() {
          return _this.rectangle && _onBoundsChanged && _onBoundsChanged(_this.rectangle.getBounds());
        },
        onDblClick: function onDblClick() {
          return _onDblClick && _onDblClick();
        },
        onClick: function onClick() {
          return _onClick && _onClick();
        },
        onMouseDown: function onMouseDown() {
          return _onMouseDown && _onMouseDown();
        },
        onMouseMove: function onMouseMove() {
          return _onMouseMove && _onMouseMove();
        },
        onMouseOut: function onMouseOut() {
          return _onMouseOut && _onMouseOut();
        },
        onMouseOver: function onMouseOver() {
          return _onMouseOver && _onMouseOver();
        },
        onMouseUp: function onMouseUp() {
          return _onMouseUp && _onMouseUp();
        },
        onRightClick: function onRightClick() {
          return _onRightClick && _onRightClick();
        }
      }), !removeMarker && /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Marker, {
        position: bounds,
        visible: false
      }));
    }
  }]);

  return MapRectangle;
}(_react.Component);

MapRectangle.defaultProps = defaultProps;
var _default = MapRectangle;
exports.default = _default;